/*
 * Form.java
 *
 * Created on 30. Mai 2007, 18:26
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package softwareprojekt;

/**
 *
 * @author PMV
 */
public class Form {
    final static int QUESTIONNUMBER = 20;
    
    String id; //ID muss 20 Zeichen beinhalten
    String [] question; //Fragetext
    int [][] answer; //Anzahl der Stimmen pro Punktmglichkeit
    
    /** Creates a new instance of Form */
    public Form(String id) {
        this.question = new String[QUESTIONNUMBER]; 
        this.answer= new int[QUESTIONNUMBER][5];
        
        if (id.length() > 20) {
            return;
        }
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            this.question[i] = "";
            for (int ii = 0; ii < 5; ii++) {
                this.answer[i][ii] = 0;
            }
        }
        
        this.id = id;
    }
    
    public Form(String id, String[] question) {
        this.answer= new int[QUESTIONNUMBER][5];

        if (id.length() > 20) {
             return;
        } else if (question.length != QUESTIONNUMBER){
            return;
        }    
        
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            for (int ii = 0; ii < 5; ii++) {
                this.answer[i][ii] = 0;
            }
        }
        this.id = id;
        this.question = question.clone();
    }
    
    public Form(String id, String[] question, int[][] answer) {

        if (id.length() > 20) {
             return;
        } else if (question.length != QUESTIONNUMBER){
            return;
        } else if (answer.length != QUESTIONNUMBER){
            return;
        }       
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            if (answer[i].length != 5){
                return;
            }
        }
        
        this.id = id;
        this.question = question.clone();
        this.answer = answer.clone();
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            this.answer[i] = answer[i].clone();
        }
    }
    
    public String getID(){
        return this.id;
    }
    
    public void setAnswer(int [][] answer){
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            if (answer[i].length != 5){
                return;
            }
        }

        this.answer = answer.clone();
        for (int i = 0; i <= QUESTIONNUMBER-1; i++){
            this.answer[i] = answer[i].clone();
        }
    }
    
    public void setAnswer(int index, int point, int value) {
        if (index >= 0 && index <= QUESTIONNUMBER-1){
            if (point >= 0 && point <= 4) {
                if (value >= 0 && value <= 4){
                    this.answer[index][point] = value;
                }
            }
        }
    }
    
    public void setQuestion(String[] text) {
        if (text.length == QUESTIONNUMBER){
            this.question = text.clone();
        }        
    }
    
    public void setQuestion(int index, String text) {
        if (index >= 0 && index <= QUESTIONNUMBER-1){
            this.question[index] = text;
        }        
    }
    
    public int getAnswer(int index, int point) {
        if (index >= 0 && index <= QUESTIONNUMBER-1){
            if (point >= 0 && point <= 4) {
                return this.answer[index][point];
            }
        }
        return -1;
    }
    
    public String [] getQuestion(){
        return this.question.clone();
    }
    
    public String getQuestion(int index) {
        if (index >= 0 && index <= QUESTIONNUMBER-1){
            return this.question[index];
        }
        return null;
    }
}
