/*
 * User.java
 *
 * Created on 30. Mai 2007, 20:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package softwareprojekt;

/**
 *
 * @author PMV
 */
public class User {
    private String id;
    private String lastname;
    private String firstname;
    private char typ;
    private String studypath;
    private int semester;
    
    //allgemeine Initialisierung
    private User(char typ, String id, String lastname, 
            String firstname, String studypath, int semster){
        if (typ != 'A' && typ != 'D' && typ != 'S'){
            return;
        } else if (id.length() > 20) {
            return;
        } else if (lastname == null || lastname.length() == 0){
            return;
        } else if ((studypath == null || studypath.length() == 0) && typ != 'A') {
            return;
        } else if ((semester < 0 || semester >= 20) && typ == 'S') {
            return;
        }
         
        this.id = id;
        this.firstname = firstname;
        this.lastname = lastname;
        this.typ = typ;
        this.studypath = studypath;
        this.semester = semester;
    }
    
    //Administrator
    public static User newAdmin(String id, String lastname, String firstname){
        return new User('A', id, lastname, firstname, null, -1);
    }
    
    //Dozent
    public static User newProf(String id, String lastname, String firstname, String studypath){
        return new User('D', id, lastname, firstname, studypath, -1);
    }
    
    //Student
    public static User newStudy(String id, String lastname, String firstname, String studypath, int semester){
        return new User('S', id, lastname, firstname, studypath, semester);
    }
    
    public String getID() {
            return this.id;
    }
    
    public String getFirstname(){
        return this.firstname;
    }
    
    public String getLastname(){
        return this.lastname;
    }
    
    public char getTyp(){
        return this.typ;
    }
    
    public String getStudypath(){
        return this.studypath;
    }
    
    public int getSemester(){
        return this.semester;
    }
}
