/*
 * Lecture.java
 *
 * Created on 30. Mai 2007, 19:07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package softwareprojekt;

import java.util.Iterator;
import java.util.Vector;

/**
 *
 * @author PMV
 */
public class Lecture {
    String shortname; //bis zu 5 Zeichen
    String name; //bis zu 40 Zeichen
    int semester;
    String studypath; //3 Zeichen
    Form form = null;
    User prof = null;
    Vector lectureDate = new Vector();
    
    public Lecture(String shortname, String name, int semester,
                    String studypath, User prof) {
        
        this.shortname = shortname;
        this.name = name;
        this.semester = semester;
        this.studypath = studypath;
        this.prof = prof;
    }
    
    public Lecture(String shortname, String name, int semester,
                    String studypath, User prof, Form form) {
        
        this.shortname = shortname;
        this.name = name;
        this.semester = semester;
        this.studypath = studypath;
        this.prof = prof;
        this.form = form;
    }
    
    public Lecture(String shortname, String name, int semester,
                    String studypath, User prof, Form form, Vector lectureDate){
        
        this.shortname = shortname;
        this.name = name;
        this.semester = semester;
        this.studypath = studypath;
        this.prof = prof;
        this.form = form;
        this.lectureDate.addAll(lectureDate);
    }
    
    public void setForm(Form form){
        this.form = form;
    }
    
    public String getShortname(){
        return this.shortname;
    }
    
    public String getName(){
        return this.name;
    }
    
    public int getSemester(){
        return this.semester;
    }
    
    public String getStudypath(){
        return this.studypath;
    }
    
    public User getProf(){
        return this.prof;
    }
    
    public Form getForm(){
        return this.form;
    }
    
    public void addLectureDate(LectureDate lectureDate){
        this.lectureDate.add(lectureDate);
    }
    
    public void removeLectureDate(int index) {
        this.lectureDate.remove(index);
    }
    
    public Vector getLectureDate(){
        return this.lectureDate;
    }
    
    public LectureDate getLectureDate(int index) {
        for (Iterator it = this.lectureDate.iterator(); it.hasNext();) {
            LectureDate date = (LectureDate) it.next();
            if (date.getIndex() == index){
                return date;
            }
        }
        return null;
    }
}
